unit MainU1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
const
  WM_DATA = WM_USER + 1024;(* PostMessage  *)
type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Button2: TButton;
    procedure InitMappedFile;
    procedure MakeMappedFile(MapName:string);
    procedure ReleaseMappedFile;
    procedure WriteToMappedFile(astring:string);
    function ReadFromMappedFile(MapName:string):string;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  DLLInstance: THandle;

implementation

{$R *.DFM}

procedure TForm1.InitMappedFile;
begin
 DLLInstance := LoadLibrary('dllmapped.dll'); // $(TestDLL) - Directory of TestDLL
 If DLLInstance = 0 then begin
   MessageDlg('Unable to load DLL.',mtError,[mbOK],0);
   Exit;
 end;
end;

procedure TForm1.MakeMappedFile( MapName:string );
type
 TOpenMap =  procedure( MapName:string );
 TLockMap=   function : Boolean;
var
 OpenMap : TOpenMap;
 LockMap : TLockMap;
begin
 @OpenMap := GetProcAddress(DLLInstance,'OpenMap');
  If @OpenMap <> nil then
     OpenMap(MapName)
 else
   MessageDlg('Unable to Open Map', mtError,[mbOK],0);
 @LockMap := GetProcAddress(DLLInstance,'LockMap');
 If @LockMap <> nil then
    LockMap
 else
   MessageDlg('Unable to Lock Map', mtError,[mbOK],0);
end;

procedure TForm1.ReleaseMappedFile;
type
  TCloseMap=  procedure;
  TUnlockMap= procedure;
var
  CloseMap : TCloseMap;
  UnlockMap : TUnlockMap;
begin
 @CloseMap := GetProcAddress(DLLInstance,'CloseMap');
  If @CloseMap <> nil then
     CloseMap
 else
   MessageDlg('Unable to Close Map', mtError,[mbOK],0);
 @UnlockMap := GetProcAddress(DLLInstance,'UnlockMap');
  If @UnlockMap <> nil then
     UnlockMap
 else
   MessageDlg('Unable to Unlock Map', mtError,[mbOK],0);
end;

procedure TForm1.WriteToMappedFile(astring:string);
type
 TWriteMap=  procedure( astring:string );
var
 WriteMap : TWriteMap;
begin
 @WriteMap := GetProcAddress(DLLInstance,'WriteMap');
 If @WriteMap <> nil then
   WriteMap(astring)
 else
   MessageDlg('Unable Write to Map', mtError,[mbOK],0);
end;

function TForm1.ReadFromMappedFile(MapName:string):string;
type
 TReadFromMap=  function( MapName:string ):pchar;
var
 ReadFromMap : TReadFromMap;
begin
 @ReadFromMap := GetProcAddress(DLLInstance,'ReadFromMap');
 If @ReadFromMap <> nil then
 begin
   Result := Pchar(ReadFromMap('Map Name'));
 end
 else
   MessageDlg('Unable Read From Map', mtError,[mbOK],0);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  InitMappedFile;
  MakeMappedFile('Map Name');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   ReleaseMappedFile;
   FreeLibrary(DLLInstance);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   (* gmapped File *)
   WriteToMappedFile(edit1.text);
   (*oe*)
   PostMessage(FindWindow(nil, 'MyForm'), WM_DATA, 1, 1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    edit2.text := ReadFromMappedFile('Map Name');
end;

end.
